<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../../common/content-types';
import { partnerBenefitsService } from '../../../services/partners/partner-benefits.service';
import { GetStartedResources } from '~/components/get-started/index.vue';
import {
  CTA as CallToAction,
  Benefits,
  FreeTrialCTA,
  NextStep,
  Hero,
} from '~/components/common/index.vue';
import {
  Carousel as QuotesCarousel,
  FeaturedPartners,
  PartnersShowcase,
  PartnersCopyBlock as TopicsCopyBlock,
} from '~/components/partners/index.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  components: {
    CallToAction,
    FeaturedPartners,
    Benefits,
    FreeTrialCTA,
    Hero,
    QuotesCarousel,
    TopicsCopyBlock,
    GetStartedResources,
    NextStep,
    PartnersShowcase,
  },
  nuxtI18n: false,
  // eslint-disable-next-line
  async asyncData({ error }: any) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'partners/benefits',
        include: 10,
      });

      const { pageContent } = response.items[0].fields;
      const seoMetadata = response.items[0].fields.seoMetadata[0].fields;

      const partner = partnerBenefitsService(pageContent);

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };
      return { partner, metadata };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
});
</script>

<template>
  <section class="partners-container">
    <component
      :is="component.name"
      v-for="(component, index) in partner.components"
      :key="component.name + index"
      :data="component.data"
    />
    <SlpContainer variant="gradient">
      <NextStep :variant="partner.next_steps_variant" />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.partners-container {
  overflow-x: hidden;
  overflow-y: show;
}
</style>
